/*
 * generated by Xtext 2.19.0.M3
 */
package fr.irisa.cairn.graphviz.model.services;

import com.google.inject.Inject;
import com.google.inject.Singleton;
import java.util.List;
import org.eclipse.xtext.Alternatives;
import org.eclipse.xtext.Assignment;
import org.eclipse.xtext.Grammar;
import org.eclipse.xtext.GrammarUtil;
import org.eclipse.xtext.Group;
import org.eclipse.xtext.Keyword;
import org.eclipse.xtext.ParserRule;
import org.eclipse.xtext.RuleCall;
import org.eclipse.xtext.TerminalRule;
import org.eclipse.xtext.common.services.TerminalsGrammarAccess;
import org.eclipse.xtext.service.AbstractElementFinder.AbstractGrammarElementFinder;
import org.eclipse.xtext.service.GrammarProvider;

@Singleton
public class DottyGrammarAccess extends AbstractGrammarElementFinder {
	
	public class GraphElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.Graph");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cDigraphKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Assignment cBodyAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cBodyCompoundParserRuleCall_2_0 = (RuleCall)cBodyAssignment_2.eContents().get(0);
		
		//Graph:
		//	'digraph' name=ID body=Compound;
		@Override public ParserRule getRule() { return rule; }
		
		//'digraph' name=ID body=Compound
		public Group getGroup() { return cGroup; }
		
		//'digraph'
		public Keyword getDigraphKeyword_0() { return cDigraphKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//body=Compound
		public Assignment getBodyAssignment_2() { return cBodyAssignment_2; }
		
		//Compound
		public RuleCall getBodyCompoundParserRuleCall_2_0() { return cBodyCompoundParserRuleCall_2_0; }
	}
	public class CompoundElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.Compound");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cLeftCurlyBracketKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Alternatives cAlternatives_1_0 = (Alternatives)cGroup_1.eContents().get(0);
		private final Group cGroup_1_0_0 = (Group)cAlternatives_1_0.eContents().get(0);
		private final Assignment cNodesAssignment_1_0_0_0 = (Assignment)cGroup_1_0_0.eContents().get(0);
		private final RuleCall cNodesNodeParserRuleCall_1_0_0_0_0 = (RuleCall)cNodesAssignment_1_0_0_0.eContents().get(0);
		private final Group cGroup_1_0_0_1 = (Group)cGroup_1_0_0.eContents().get(1);
		private final Keyword cHyphenMinusGreaterThanSignKeyword_1_0_0_1_0 = (Keyword)cGroup_1_0_0_1.eContents().get(0);
		private final Assignment cNodesAssignment_1_0_0_1_1 = (Assignment)cGroup_1_0_0_1.eContents().get(1);
		private final RuleCall cNodesNodeParserRuleCall_1_0_0_1_1_0 = (RuleCall)cNodesAssignment_1_0_0_1_1.eContents().get(0);
		private final Assignment cAttributesAssignment_1_0_1 = (Assignment)cAlternatives_1_0.eContents().get(1);
		private final RuleCall cAttributesAttributeParserRuleCall_1_0_1_0 = (RuleCall)cAttributesAssignment_1_0_1.eContents().get(0);
		private final Assignment cSubAssignment_1_0_2 = (Assignment)cAlternatives_1_0.eContents().get(2);
		private final RuleCall cSubCompoundParserRuleCall_1_0_2_0 = (RuleCall)cSubAssignment_1_0_2.eContents().get(0);
		private final Keyword cSemicolonKeyword_1_1 = (Keyword)cGroup_1.eContents().get(1);
		private final Keyword cRightCurlyBracketKeyword_2 = (Keyword)cGroup.eContents().get(2);
		
		//Compound:
		//	'{' ((nodes+=Node ('->' nodes+=Node)* | attributes+=Attribute | sub+=Compound) ';'?)*
		//	'}';
		@Override public ParserRule getRule() { return rule; }
		
		//'{' ((nodes+=Node ('->' nodes+=Node)* | attributes+=Attribute | sub+=Compound) ';'?)* '}'
		public Group getGroup() { return cGroup; }
		
		//'{'
		public Keyword getLeftCurlyBracketKeyword_0() { return cLeftCurlyBracketKeyword_0; }
		
		//((nodes+=Node ('->' nodes+=Node)* | attributes+=Attribute | sub+=Compound) ';'?)*
		public Group getGroup_1() { return cGroup_1; }
		
		//(nodes+=Node ('->' nodes+=Node)* | attributes+=Attribute | sub+=Compound)
		public Alternatives getAlternatives_1_0() { return cAlternatives_1_0; }
		
		//nodes+=Node ('->' nodes+=Node)*
		public Group getGroup_1_0_0() { return cGroup_1_0_0; }
		
		//nodes+=Node
		public Assignment getNodesAssignment_1_0_0_0() { return cNodesAssignment_1_0_0_0; }
		
		//Node
		public RuleCall getNodesNodeParserRuleCall_1_0_0_0_0() { return cNodesNodeParserRuleCall_1_0_0_0_0; }
		
		//('->' nodes+=Node)*
		public Group getGroup_1_0_0_1() { return cGroup_1_0_0_1; }
		
		//'->'
		public Keyword getHyphenMinusGreaterThanSignKeyword_1_0_0_1_0() { return cHyphenMinusGreaterThanSignKeyword_1_0_0_1_0; }
		
		//nodes+=Node
		public Assignment getNodesAssignment_1_0_0_1_1() { return cNodesAssignment_1_0_0_1_1; }
		
		//Node
		public RuleCall getNodesNodeParserRuleCall_1_0_0_1_1_0() { return cNodesNodeParserRuleCall_1_0_0_1_1_0; }
		
		//attributes+=Attribute
		public Assignment getAttributesAssignment_1_0_1() { return cAttributesAssignment_1_0_1; }
		
		//Attribute
		public RuleCall getAttributesAttributeParserRuleCall_1_0_1_0() { return cAttributesAttributeParserRuleCall_1_0_1_0; }
		
		//sub+=Compound
		public Assignment getSubAssignment_1_0_2() { return cSubAssignment_1_0_2; }
		
		//Compound
		public RuleCall getSubCompoundParserRuleCall_1_0_2_0() { return cSubCompoundParserRuleCall_1_0_2_0; }
		
		//';'?
		public Keyword getSemicolonKeyword_1_1() { return cSemicolonKeyword_1_1; }
		
		//'}'
		public Keyword getRightCurlyBracketKeyword_2() { return cRightCurlyBracketKeyword_2; }
	}
	public class NodeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.Node");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cLeafNodeParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cSubNodeParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		
		//Node:
		//	LeafNode | SubNode;
		@Override public ParserRule getRule() { return rule; }
		
		//LeafNode | SubNode
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//LeafNode
		public RuleCall getLeafNodeParserRuleCall_0() { return cLeafNodeParserRuleCall_0; }
		
		//SubNode
		public RuleCall getSubNodeParserRuleCall_1() { return cSubNodeParserRuleCall_1; }
	}
	public class LeafNodeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.LeafNode");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Assignment cNameAssignment_0 = (Assignment)cGroup.eContents().get(0);
		private final RuleCall cNameIDTerminalRuleCall_0_0 = (RuleCall)cNameAssignment_0.eContents().get(0);
		private final Group cGroup_1 = (Group)cGroup.eContents().get(1);
		private final Keyword cLeftSquareBracketKeyword_1_0 = (Keyword)cGroup_1.eContents().get(0);
		private final Assignment cAttributesAssignment_1_1 = (Assignment)cGroup_1.eContents().get(1);
		private final RuleCall cAttributesAttributeParserRuleCall_1_1_0 = (RuleCall)cAttributesAssignment_1_1.eContents().get(0);
		private final Group cGroup_1_2 = (Group)cGroup_1.eContents().get(2);
		private final Keyword cCommaKeyword_1_2_0 = (Keyword)cGroup_1_2.eContents().get(0);
		private final Assignment cAttributesAssignment_1_2_1 = (Assignment)cGroup_1_2.eContents().get(1);
		private final RuleCall cAttributesAttributeParserRuleCall_1_2_1_0 = (RuleCall)cAttributesAssignment_1_2_1.eContents().get(0);
		private final Keyword cRightSquareBracketKeyword_1_3 = (Keyword)cGroup_1.eContents().get(3);
		
		//LeafNode:
		//	name=ID ('[' attributes+=Attribute (',' attributes+=Attribute)* ']')?;
		@Override public ParserRule getRule() { return rule; }
		
		//name=ID ('[' attributes+=Attribute (',' attributes+=Attribute)* ']')?
		public Group getGroup() { return cGroup; }
		
		//name=ID
		public Assignment getNameAssignment_0() { return cNameAssignment_0; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_0_0() { return cNameIDTerminalRuleCall_0_0; }
		
		//('[' attributes+=Attribute (',' attributes+=Attribute)* ']')?
		public Group getGroup_1() { return cGroup_1; }
		
		//'['
		public Keyword getLeftSquareBracketKeyword_1_0() { return cLeftSquareBracketKeyword_1_0; }
		
		//attributes+=Attribute
		public Assignment getAttributesAssignment_1_1() { return cAttributesAssignment_1_1; }
		
		//Attribute
		public RuleCall getAttributesAttributeParserRuleCall_1_1_0() { return cAttributesAttributeParserRuleCall_1_1_0; }
		
		//(',' attributes+=Attribute)*
		public Group getGroup_1_2() { return cGroup_1_2; }
		
		//','
		public Keyword getCommaKeyword_1_2_0() { return cCommaKeyword_1_2_0; }
		
		//attributes+=Attribute
		public Assignment getAttributesAssignment_1_2_1() { return cAttributesAssignment_1_2_1; }
		
		//Attribute
		public RuleCall getAttributesAttributeParserRuleCall_1_2_1_0() { return cAttributesAttributeParserRuleCall_1_2_1_0; }
		
		//']'
		public Keyword getRightSquareBracketKeyword_1_3() { return cRightSquareBracketKeyword_1_3; }
	}
	public class SubNodeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.SubNode");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cSubgraphKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Assignment cNameAssignment_1 = (Assignment)cGroup.eContents().get(1);
		private final RuleCall cNameIDTerminalRuleCall_1_0 = (RuleCall)cNameAssignment_1.eContents().get(0);
		private final Assignment cBodyAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cBodyCompoundParserRuleCall_2_0 = (RuleCall)cBodyAssignment_2.eContents().get(0);
		
		//SubNode:
		//	'subgraph' name=ID body=Compound;
		@Override public ParserRule getRule() { return rule; }
		
		//'subgraph' name=ID body=Compound
		public Group getGroup() { return cGroup; }
		
		//'subgraph'
		public Keyword getSubgraphKeyword_0() { return cSubgraphKeyword_0; }
		
		//name=ID
		public Assignment getNameAssignment_1() { return cNameAssignment_1; }
		
		//ID
		public RuleCall getNameIDTerminalRuleCall_1_0() { return cNameIDTerminalRuleCall_1_0; }
		
		//body=Compound
		public Assignment getBodyAssignment_2() { return cBodyAssignment_2; }
		
		//Compound
		public RuleCall getBodyCompoundParserRuleCall_2_0() { return cBodyCompoundParserRuleCall_2_0; }
	}
	public class AttributeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.Attribute");
		private final Alternatives cAlternatives = (Alternatives)rule.eContents().get(1);
		private final RuleCall cRankAttributeParserRuleCall_0 = (RuleCall)cAlternatives.eContents().get(0);
		private final RuleCall cShapeAttributeParserRuleCall_1 = (RuleCall)cAlternatives.eContents().get(1);
		private final RuleCall cColorAttributeParserRuleCall_2 = (RuleCall)cAlternatives.eContents().get(2);
		private final RuleCall cLabelAttributeParserRuleCall_3 = (RuleCall)cAlternatives.eContents().get(3);
		private final RuleCall cStyleAttributeParserRuleCall_4 = (RuleCall)cAlternatives.eContents().get(4);
		private final RuleCall cCompoundAttributeParserRuleCall_5 = (RuleCall)cAlternatives.eContents().get(5);
		
		//Attribute:
		//	RankAttribute | ShapeAttribute | ColorAttribute | LabelAttribute | StyleAttribute | CompoundAttribute;
		@Override public ParserRule getRule() { return rule; }
		
		//RankAttribute | ShapeAttribute | ColorAttribute | LabelAttribute | StyleAttribute | CompoundAttribute
		public Alternatives getAlternatives() { return cAlternatives; }
		
		//RankAttribute
		public RuleCall getRankAttributeParserRuleCall_0() { return cRankAttributeParserRuleCall_0; }
		
		//ShapeAttribute
		public RuleCall getShapeAttributeParserRuleCall_1() { return cShapeAttributeParserRuleCall_1; }
		
		//ColorAttribute
		public RuleCall getColorAttributeParserRuleCall_2() { return cColorAttributeParserRuleCall_2; }
		
		//LabelAttribute
		public RuleCall getLabelAttributeParserRuleCall_3() { return cLabelAttributeParserRuleCall_3; }
		
		//StyleAttribute
		public RuleCall getStyleAttributeParserRuleCall_4() { return cStyleAttributeParserRuleCall_4; }
		
		//CompoundAttribute
		public RuleCall getCompoundAttributeParserRuleCall_5() { return cCompoundAttributeParserRuleCall_5; }
	}
	public class ShapeAttributeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.ShapeAttribute");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cShapeKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cEqualsSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cShapeAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final Alternatives cShapeAlternatives_2_0 = (Alternatives)cShapeAssignment_2.eContents().get(0);
		private final RuleCall cShapeIDTerminalRuleCall_2_0_0 = (RuleCall)cShapeAlternatives_2_0.eContents().get(0);
		private final RuleCall cShapeSTRINGTerminalRuleCall_2_0_1 = (RuleCall)cShapeAlternatives_2_0.eContents().get(1);
		
		//ShapeAttribute:
		//	"shape" '=' shape=(ID | STRING);
		@Override public ParserRule getRule() { return rule; }
		
		//"shape" '=' shape=(ID | STRING)
		public Group getGroup() { return cGroup; }
		
		//"shape"
		public Keyword getShapeKeyword_0() { return cShapeKeyword_0; }
		
		//'='
		public Keyword getEqualsSignKeyword_1() { return cEqualsSignKeyword_1; }
		
		//shape=(ID | STRING)
		public Assignment getShapeAssignment_2() { return cShapeAssignment_2; }
		
		//(ID | STRING)
		public Alternatives getShapeAlternatives_2_0() { return cShapeAlternatives_2_0; }
		
		//ID
		public RuleCall getShapeIDTerminalRuleCall_2_0_0() { return cShapeIDTerminalRuleCall_2_0_0; }
		
		//STRING
		public RuleCall getShapeSTRINGTerminalRuleCall_2_0_1() { return cShapeSTRINGTerminalRuleCall_2_0_1; }
	}
	public class CompoundAttributeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.CompoundAttribute");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cCompoundKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cEqualsSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cCompoundAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final Alternatives cCompoundAlternatives_2_0 = (Alternatives)cCompoundAssignment_2.eContents().get(0);
		private final Keyword cCompoundTrueKeyword_2_0_0 = (Keyword)cCompoundAlternatives_2_0.eContents().get(0);
		private final Keyword cCompoundFalseKeyword_2_0_1 = (Keyword)cCompoundAlternatives_2_0.eContents().get(1);
		
		//CompoundAttribute:
		//	"compound" '=' compound=("true" | " false");
		@Override public ParserRule getRule() { return rule; }
		
		//"compound" '=' compound=("true" | " false")
		public Group getGroup() { return cGroup; }
		
		//"compound"
		public Keyword getCompoundKeyword_0() { return cCompoundKeyword_0; }
		
		//'='
		public Keyword getEqualsSignKeyword_1() { return cEqualsSignKeyword_1; }
		
		//compound=("true" | " false")
		public Assignment getCompoundAssignment_2() { return cCompoundAssignment_2; }
		
		//("true" | " false")
		public Alternatives getCompoundAlternatives_2_0() { return cCompoundAlternatives_2_0; }
		
		//"true"
		public Keyword getCompoundTrueKeyword_2_0_0() { return cCompoundTrueKeyword_2_0_0; }
		
		//" false"
		public Keyword getCompoundFalseKeyword_2_0_1() { return cCompoundFalseKeyword_2_0_1; }
	}
	public class ColorAttributeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.ColorAttribute");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Alternatives cAlternatives_0 = (Alternatives)cGroup.eContents().get(0);
		private final Keyword cColorKeyword_0_0 = (Keyword)cAlternatives_0.eContents().get(0);
		private final Keyword cFillcolorKeyword_0_1 = (Keyword)cAlternatives_0.eContents().get(1);
		private final Keyword cFontcolorKeyword_0_2 = (Keyword)cAlternatives_0.eContents().get(2);
		private final Keyword cEqualsSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cColorAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final Alternatives cColorAlternatives_2_0 = (Alternatives)cColorAssignment_2.eContents().get(0);
		private final RuleCall cColorIDTerminalRuleCall_2_0_0 = (RuleCall)cColorAlternatives_2_0.eContents().get(0);
		private final RuleCall cColorSTRINGTerminalRuleCall_2_0_1 = (RuleCall)cColorAlternatives_2_0.eContents().get(1);
		
		//ColorAttribute:
		//	("color" | "fillcolor" | "fontcolor") '=' color=(ID | STRING);
		@Override public ParserRule getRule() { return rule; }
		
		//("color" | "fillcolor" | "fontcolor") '=' color=(ID | STRING)
		public Group getGroup() { return cGroup; }
		
		//("color" | "fillcolor" | "fontcolor")
		public Alternatives getAlternatives_0() { return cAlternatives_0; }
		
		//"color"
		public Keyword getColorKeyword_0_0() { return cColorKeyword_0_0; }
		
		//"fillcolor"
		public Keyword getFillcolorKeyword_0_1() { return cFillcolorKeyword_0_1; }
		
		//"fontcolor"
		public Keyword getFontcolorKeyword_0_2() { return cFontcolorKeyword_0_2; }
		
		//'='
		public Keyword getEqualsSignKeyword_1() { return cEqualsSignKeyword_1; }
		
		//color=(ID | STRING)
		public Assignment getColorAssignment_2() { return cColorAssignment_2; }
		
		//(ID | STRING)
		public Alternatives getColorAlternatives_2_0() { return cColorAlternatives_2_0; }
		
		//ID
		public RuleCall getColorIDTerminalRuleCall_2_0_0() { return cColorIDTerminalRuleCall_2_0_0; }
		
		//STRING
		public RuleCall getColorSTRINGTerminalRuleCall_2_0_1() { return cColorSTRINGTerminalRuleCall_2_0_1; }
	}
	public class StyleAttributeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.StyleAttribute");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cStyleKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cEqualsSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cStyleAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final Alternatives cStyleAlternatives_2_0 = (Alternatives)cStyleAssignment_2.eContents().get(0);
		private final RuleCall cStyleIDTerminalRuleCall_2_0_0 = (RuleCall)cStyleAlternatives_2_0.eContents().get(0);
		private final RuleCall cStyleSTRINGTerminalRuleCall_2_0_1 = (RuleCall)cStyleAlternatives_2_0.eContents().get(1);
		
		//StyleAttribute:
		//	"style" '=' style=(ID | STRING);
		@Override public ParserRule getRule() { return rule; }
		
		//"style" '=' style=(ID | STRING)
		public Group getGroup() { return cGroup; }
		
		//"style"
		public Keyword getStyleKeyword_0() { return cStyleKeyword_0; }
		
		//'='
		public Keyword getEqualsSignKeyword_1() { return cEqualsSignKeyword_1; }
		
		//style=(ID | STRING)
		public Assignment getStyleAssignment_2() { return cStyleAssignment_2; }
		
		//(ID | STRING)
		public Alternatives getStyleAlternatives_2_0() { return cStyleAlternatives_2_0; }
		
		//ID
		public RuleCall getStyleIDTerminalRuleCall_2_0_0() { return cStyleIDTerminalRuleCall_2_0_0; }
		
		//STRING
		public RuleCall getStyleSTRINGTerminalRuleCall_2_0_1() { return cStyleSTRINGTerminalRuleCall_2_0_1; }
	}
	public class LabelAttributeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.LabelAttribute");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cLabelKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cEqualsSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cLabelAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final RuleCall cLabelSTRINGTerminalRuleCall_2_0 = (RuleCall)cLabelAssignment_2.eContents().get(0);
		
		//LabelAttribute:
		//	"label" '=' label=STRING;
		@Override public ParserRule getRule() { return rule; }
		
		//"label" '=' label=STRING
		public Group getGroup() { return cGroup; }
		
		//"label"
		public Keyword getLabelKeyword_0() { return cLabelKeyword_0; }
		
		//'='
		public Keyword getEqualsSignKeyword_1() { return cEqualsSignKeyword_1; }
		
		//label=STRING
		public Assignment getLabelAssignment_2() { return cLabelAssignment_2; }
		
		//STRING
		public RuleCall getLabelSTRINGTerminalRuleCall_2_0() { return cLabelSTRINGTerminalRuleCall_2_0; }
	}
	public class RankAttributeElements extends AbstractParserRuleElementFinder {
		private final ParserRule rule = (ParserRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.RankAttribute");
		private final Group cGroup = (Group)rule.eContents().get(1);
		private final Keyword cRankdirKeyword_0 = (Keyword)cGroup.eContents().get(0);
		private final Keyword cEqualsSignKeyword_1 = (Keyword)cGroup.eContents().get(1);
		private final Assignment cDirectionAssignment_2 = (Assignment)cGroup.eContents().get(2);
		private final Alternatives cDirectionAlternatives_2_0 = (Alternatives)cDirectionAssignment_2.eContents().get(0);
		private final Keyword cDirectionTBKeyword_2_0_0 = (Keyword)cDirectionAlternatives_2_0.eContents().get(0);
		private final Keyword cDirectionLRKeyword_2_0_1 = (Keyword)cDirectionAlternatives_2_0.eContents().get(1);
		private final Keyword cDirectionBTKeyword_2_0_2 = (Keyword)cDirectionAlternatives_2_0.eContents().get(2);
		private final Keyword cDirectionRLKeyword_2_0_3 = (Keyword)cDirectionAlternatives_2_0.eContents().get(3);
		
		//RankAttribute:
		//	"rankdir" '=' direction=("TB" | "LR" | "BT" | "RL");
		@Override public ParserRule getRule() { return rule; }
		
		//"rankdir" '=' direction=("TB" | "LR" | "BT" | "RL")
		public Group getGroup() { return cGroup; }
		
		//"rankdir"
		public Keyword getRankdirKeyword_0() { return cRankdirKeyword_0; }
		
		//'='
		public Keyword getEqualsSignKeyword_1() { return cEqualsSignKeyword_1; }
		
		//direction=("TB" | "LR" | "BT" | "RL")
		public Assignment getDirectionAssignment_2() { return cDirectionAssignment_2; }
		
		//("TB" | "LR" | "BT" | "RL")
		public Alternatives getDirectionAlternatives_2_0() { return cDirectionAlternatives_2_0; }
		
		//"TB"
		public Keyword getDirectionTBKeyword_2_0_0() { return cDirectionTBKeyword_2_0_0; }
		
		//"LR"
		public Keyword getDirectionLRKeyword_2_0_1() { return cDirectionLRKeyword_2_0_1; }
		
		//"BT"
		public Keyword getDirectionBTKeyword_2_0_2() { return cDirectionBTKeyword_2_0_2; }
		
		//"RL"
		public Keyword getDirectionRLKeyword_2_0_3() { return cDirectionRLKeyword_2_0_3; }
	}
	
	
	private final GraphElements pGraph;
	private final CompoundElements pCompound;
	private final NodeElements pNode;
	private final LeafNodeElements pLeafNode;
	private final SubNodeElements pSubNode;
	private final AttributeElements pAttribute;
	private final ShapeAttributeElements pShapeAttribute;
	private final CompoundAttributeElements pCompoundAttribute;
	private final ColorAttributeElements pColorAttribute;
	private final StyleAttributeElements pStyleAttribute;
	private final LabelAttributeElements pLabelAttribute;
	private final RankAttributeElements pRankAttribute;
	private final TerminalRule tSTRING;
	
	private final Grammar grammar;
	
	private final TerminalsGrammarAccess gaTerminals;

	@Inject
	public DottyGrammarAccess(GrammarProvider grammarProvider,
			TerminalsGrammarAccess gaTerminals) {
		this.grammar = internalFindGrammar(grammarProvider);
		this.gaTerminals = gaTerminals;
		this.pGraph = new GraphElements();
		this.pCompound = new CompoundElements();
		this.pNode = new NodeElements();
		this.pLeafNode = new LeafNodeElements();
		this.pSubNode = new SubNodeElements();
		this.pAttribute = new AttributeElements();
		this.pShapeAttribute = new ShapeAttributeElements();
		this.pCompoundAttribute = new CompoundAttributeElements();
		this.pColorAttribute = new ColorAttributeElements();
		this.pStyleAttribute = new StyleAttributeElements();
		this.pLabelAttribute = new LabelAttributeElements();
		this.pRankAttribute = new RankAttributeElements();
		this.tSTRING = (TerminalRule) GrammarUtil.findRuleForName(getGrammar(), "fr.irisa.cairn.graphviz.model.Dotty.STRING");
	}
	
	protected Grammar internalFindGrammar(GrammarProvider grammarProvider) {
		Grammar grammar = grammarProvider.getGrammar(this);
		while (grammar != null) {
			if ("fr.irisa.cairn.graphviz.model.Dotty".equals(grammar.getName())) {
				return grammar;
			}
			List<Grammar> grammars = grammar.getUsedGrammars();
			if (!grammars.isEmpty()) {
				grammar = grammars.iterator().next();
			} else {
				return null;
			}
		}
		return grammar;
	}
	
	@Override
	public Grammar getGrammar() {
		return grammar;
	}
	
	
	public TerminalsGrammarAccess getTerminalsGrammarAccess() {
		return gaTerminals;
	}

	
	//Graph:
	//	'digraph' name=ID body=Compound;
	public GraphElements getGraphAccess() {
		return pGraph;
	}
	
	public ParserRule getGraphRule() {
		return getGraphAccess().getRule();
	}
	
	//Compound:
	//	'{' ((nodes+=Node ('->' nodes+=Node)* | attributes+=Attribute | sub+=Compound) ';'?)*
	//	'}';
	public CompoundElements getCompoundAccess() {
		return pCompound;
	}
	
	public ParserRule getCompoundRule() {
		return getCompoundAccess().getRule();
	}
	
	//Node:
	//	LeafNode | SubNode;
	public NodeElements getNodeAccess() {
		return pNode;
	}
	
	public ParserRule getNodeRule() {
		return getNodeAccess().getRule();
	}
	
	//LeafNode:
	//	name=ID ('[' attributes+=Attribute (',' attributes+=Attribute)* ']')?;
	public LeafNodeElements getLeafNodeAccess() {
		return pLeafNode;
	}
	
	public ParserRule getLeafNodeRule() {
		return getLeafNodeAccess().getRule();
	}
	
	//SubNode:
	//	'subgraph' name=ID body=Compound;
	public SubNodeElements getSubNodeAccess() {
		return pSubNode;
	}
	
	public ParserRule getSubNodeRule() {
		return getSubNodeAccess().getRule();
	}
	
	//Attribute:
	//	RankAttribute | ShapeAttribute | ColorAttribute | LabelAttribute | StyleAttribute | CompoundAttribute;
	public AttributeElements getAttributeAccess() {
		return pAttribute;
	}
	
	public ParserRule getAttributeRule() {
		return getAttributeAccess().getRule();
	}
	
	//ShapeAttribute:
	//	"shape" '=' shape=(ID | STRING);
	public ShapeAttributeElements getShapeAttributeAccess() {
		return pShapeAttribute;
	}
	
	public ParserRule getShapeAttributeRule() {
		return getShapeAttributeAccess().getRule();
	}
	
	//CompoundAttribute:
	//	"compound" '=' compound=("true" | " false");
	public CompoundAttributeElements getCompoundAttributeAccess() {
		return pCompoundAttribute;
	}
	
	public ParserRule getCompoundAttributeRule() {
		return getCompoundAttributeAccess().getRule();
	}
	
	//ColorAttribute:
	//	("color" | "fillcolor" | "fontcolor") '=' color=(ID | STRING);
	public ColorAttributeElements getColorAttributeAccess() {
		return pColorAttribute;
	}
	
	public ParserRule getColorAttributeRule() {
		return getColorAttributeAccess().getRule();
	}
	
	//StyleAttribute:
	//	"style" '=' style=(ID | STRING);
	public StyleAttributeElements getStyleAttributeAccess() {
		return pStyleAttribute;
	}
	
	public ParserRule getStyleAttributeRule() {
		return getStyleAttributeAccess().getRule();
	}
	
	//LabelAttribute:
	//	"label" '=' label=STRING;
	public LabelAttributeElements getLabelAttributeAccess() {
		return pLabelAttribute;
	}
	
	public ParserRule getLabelAttributeRule() {
		return getLabelAttributeAccess().getRule();
	}
	
	//RankAttribute:
	//	"rankdir" '=' direction=("TB" | "LR" | "BT" | "RL");
	public RankAttributeElements getRankAttributeAccess() {
		return pRankAttribute;
	}
	
	public ParserRule getRankAttributeRule() {
		return getRankAttributeAccess().getRule();
	}
	
	//terminal STRING:
	//	'"'->'"';
	public TerminalRule getSTRINGRule() {
		return tSTRING;
	}
	
	//terminal ID:
	//	'^'? ('a'..'z' | 'A'..'Z' | '_') ('a'..'z' | 'A'..'Z' | '_' | '0'..'9')*;
	public TerminalRule getIDRule() {
		return gaTerminals.getIDRule();
	}
	
	//terminal INT returns ecore::EInt:
	//	'0'..'9'+;
	public TerminalRule getINTRule() {
		return gaTerminals.getINTRule();
	}
	
	//terminal ML_COMMENT:
	//	'/*'->'*/';
	public TerminalRule getML_COMMENTRule() {
		return gaTerminals.getML_COMMENTRule();
	}
	
	//terminal SL_COMMENT:
	//	'//' !('\n' | '\r')* ('\r'? '\n')?;
	public TerminalRule getSL_COMMENTRule() {
		return gaTerminals.getSL_COMMENTRule();
	}
	
	//terminal WS:
	//	' ' | '\t' | '\r' | '\n'+;
	public TerminalRule getWSRule() {
		return gaTerminals.getWSRule();
	}
	
	//terminal ANY_OTHER:
	//	.;
	public TerminalRule getANY_OTHERRule() {
		return gaTerminals.getANY_OTHERRule();
	}
}
